## libaec 1.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.26...3.31)
project(libaec LANGUAGES C VERSION 1.1.5)

option(BUILD_SHARED_LIBS "OFF: do not build shared libraries.  ON (default): build shared libraries" ON)
option(BUILD_STATIC_LIBS "OFF: do not build static libraries.  ON (default): build static libraries" ON)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
include(CTest)
include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

# Check for __builtin_clzll for faster decoding
include(CheckCSourceCompiles)
check_c_source_compiles(
  "int main(void)\n{return __builtin_clzll(1LL);}"
  HAVE_DECL___BUILTIN_CLZLL)

if(NOT HAVE_DECL___BUILTIN_CLZLL)
  # With MSVC we can use _BitScanReverse64
  check_c_source_compiles(
    "int main(void){unsigned long foo; unsigned __int64 bar=1LL;
return _BitScanReverse64(&foo, bar);}"
    HAVE_BSR64)
endif()

include(CheckSymbolExists)
check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
if(NOT HAVE_SNPRINTF)
  check_symbol_exists(_snprintf "stdio.h" HAVE__SNPRINTF)
  check_symbol_exists(_snprintf_s "stdio.h" HAVE__SNPRINTF_S)
endif()

# Communicate findings to code. Has to be compatible with autoconf's config.h.
configure_file(
  "include/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/include/config.h")

# Create libaec.h with current version information
configure_file(
  "include/libaec.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/include/libaec.h")

add_subdirectory(src)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

option(AEC_FUZZING "Enable build of fuzzing target" OFF)
if(AEC_FUZZING)
  enable_language(CXX)

  if(NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(FATAL_ERROR "You need to build with Clang for fuzzing to work")
  endif()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "6.0.0")
    message(FATAL_ERROR "You need Clang ≥ 6.0.0")
  endif()

  add_subdirectory(fuzzing)
  set(FUZZ_TARGET_SAN_FLAGS -fsanitize=fuzzer-no-link,address,undefined)
  target_compile_options(aec PUBLIC -g -O1 ${FUZZ_TARGET_SAN_FLAGS})
  target_link_options(aec PUBLIC ${FUZZ_TARGET_SAN_FLAGS})
endif()

# Include the install rules if the user wanted them (included by
# default when top-level)

string(COMPARE
  EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}" is_top_level)
option(libaec_INCLUDE_PACKAGING
  "Include packaging rules for libaec" "${is_top_level}")
if(libaec_INCLUDE_PACKAGING)
  add_subdirectory(packaging)
endif()

=== packaging/CMakeLists.txt ===
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

if(NOT DEFINED libaec_INSTALL_CMAKEDIR)
  set(libaec_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/libaec"
    CACHE STRING "Path to libaec CMake files")
endif()

write_basic_package_version_file(
  libaec-config-version.cmake
  COMPATIBILITY SameMajorVersion)

install(FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/libaec-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/libaec-config-version.cmake"
  DESTINATION "${libaec_INSTALL_CMAKEDIR}")

set(TARGETS_EXPORT)
if(BUILD_SHARED_LIBS)
  set(TARGETS_EXPORT aec-shared-objects sz-shared-objects aec-shared sz-shared)

  install(TARGETS ${TARGETS_EXPORT}
    EXPORT libaec_shared_targets
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

  install(EXPORT libaec_shared_targets
    DESTINATION "${libaec_INSTALL_CMAKEDIR}"
    NAMESPACE libaec::
    FILE libaec_shared-targets.cmake)
endif()
if(BUILD_STATIC_LIBS)
  set(TARGETS_EXPORT aec-static-objects sz-static-objects aec-static sz-static)

  install(TARGETS ${TARGETS_EXPORT}
    EXPORT libaec_static_targets
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

  install(EXPORT libaec_shared_targets
    DESTINATION "${libaec_INSTALL_CMAKEDIR}"
    NAMESPACE libaec::
    FILE libaec_static-targets.cmake)
endif()

# Cpack configuration mainly for Windows installer
set(CPACK_PACKAGE_NAME "libaec")
set(CPACK_PACKAGE_VENDOR "Deutsches Klimarechenzentrum GmbH")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY
  "libaec - Adaptive Entropy Coding library")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "libaec")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE.txt")

if(WIN32)
  set(CPACK_GENERATOR "WIX")
  set(CPACK_WIX_UPGRADE_GUID "E58A21F6-BB99-46B5-8AD8-6114E4CCA0A6")
endif()

set(CPACK_SOURCE_IGNORE_FILES /.git;.*~)

include(CPack)

=== src/CMakeLists.txt ===
# Shared and static versions of aec and sz. Also build graec tool for
# internal use.

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
  message(FATAL_ERROR
    "At least one out of BUILD_SHARED_LIBS and BUILD_STATIC_LIBS must be selected")
endif()

# Sources for libaec
set(libaec_sources
  encode.c
  encode_accessors.c
  decode.c
  vector.c)

# Properties for all shared and static libraries
macro(aec_common_include aec_target aec_header)
  target_include_directories(${aec_target}
    PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../include>"
    "$<INSTALL_INTERFACE:include>")
  set_target_properties(${aec_target}
    PROPERTIES
    PUBLIC_HEADER "${aec_header}")
endmacro()

# Public header files
set(libaec_header "${CMAKE_CURRENT_BINARY_DIR}/../include/libaec.h")
set(szlib_header "${CMAKE_CURRENT_SOURCE_DIR}/../include/szlib.h")

# Optionally, create both static and shared aec library.
if(BUILD_SHARED_LIBS)
  # Shared libaec
  add_library(aec-shared-objects OBJECT ${libaec_sources})
  aec_common_include(aec-shared-objects "${libaec_header}")
  target_compile_definitions(aec-shared-objects
    PUBLIC "LIBAEC_SHARED"
    PRIVATE "LIBAEC_BUILD")
  add_library(aec-shared SHARED "$<TARGET_OBJECTS:aec-shared-objects>")
  target_link_libraries(aec-shared PUBLIC aec-shared-objects)

  # Shared libaec versioning
  set(libaec_VERSION_MAJOR 0)
  set(libaec_VERSION_MINOR 1)
  set(libaec_VERSION_PATCH 5)

  # libtool compatible versioning for Mach-O
  math(EXPR libaec_MACHO_COMPATIBILITY_VERSION
    "${libaec_VERSION_MAJOR} + ${libaec_VERSION_MINOR} + 1")
  set(libaec_MACHO_CURRENT_VERSION
    "${libaec_MACHO_COMPATIBILITY_VERSION}.${libaec_VERSION_PATCH}")

  set_target_properties(aec-shared
    PROPERTIES
    VERSION "${libaec_VERSION_MAJOR}.${libaec_VERSION_MINOR}.${libaec_VERSION_PATCH}"
    SOVERSION "${libaec_VERSION_MAJOR}"
    MACHO_COMPATIBILITY_VERSION "${libaec_MACHO_COMPATIBILITY_VERSION}"
    MACHO_CURRENT_VERSION "${libaec_MACHO_CURRENT_VERSION}"
    OUTPUT_NAME aec)

  # Shared libsz
  add_library(sz-shared-objects OBJECT sz_compat.c)
  aec_common_include(sz-shared-objects "${szlib_header}")
  target_compile_definitions(sz-shared-objects
    PUBLIC "LIBAEC_SHARED"
    PRIVATE "LIBAEC_BUILD")
  add_library(sz-shared SHARED
    "$<TARGET_OBJECTS:sz-shared-objects>"
    "$<TARGET_OBJECTS:aec-shared-objects>")
  target_link_libraries(sz-shared PUBLIC sz-shared-objects)

  # Shared libsz versioning
  set(sz_VERSION_MAJOR 2)
  set(sz_VERSION_MINOR 0)
  set(sz_VERSION_PATCH 1)

  math(EXPR sz_MACHO_COMPATIBILITY_VERSION
    "${sz_VERSION_MAJOR} + ${sz_VERSION_MINOR} + 1")
  set(sz_MACHO_CURRENT_VERSION
    "${sz_MACHO_COMPATIBILITY_VERSION}.${sz_VERSION_PATCH}")

  set_target_properties(sz-shared
    PROPERTIES
    VERSION "${sz_VERSION_MAJOR}.${sz_VERSION_MINOR}.${sz_VERSION_PATCH}"
    SOVERSION "${sz_VERSION_MAJOR}"
    MACHO_COMPATIBILITY_VERSION "${sz_MACHO_COMPATIBILITY_VERSION}"
    MACHO_CURRENT_VERSION "${sz_MACHO_CURRENT_VERSION}"
    OUTPUT_NAME sz)
  if(MSVC OR ("${CMAKE_C_SIMULATE_ID}" STREQUAL "MSVC"))
    set_target_properties(sz-shared PROPERTIES OUTPUT_NAME szip)
  endif()
  # Add include directory directly to sz-shared so config can get it.
  target_include_directories(sz-shared
    PUBLIC "$<INSTALL_INTERFACE:include>")

  # Aliases for other tools. Prefer shared.
  add_library(libaec::aec ALIAS aec-shared)
  add_library(libaec::sz ALIAS sz-shared)
endif()

if(BUILD_STATIC_LIBS)
  # Static libaec
  add_library(aec-static-objects OBJECT ${libaec_sources})
  aec_common_include(aec-static-objects "${libaec_header}")
  add_library(aec-static STATIC "$<TARGET_OBJECTS:aec-static-objects>")
  target_link_libraries(aec-static PUBLIC aec-static-objects)
  set_target_properties(aec-static PROPERTIES OUTPUT_NAME aec)
  if(MSVC OR ("${CMAKE_C_SIMULATE_ID}" STREQUAL "MSVC"))
    set_target_properties(aec-static PROPERTIES OUTPUT_NAME aec-static)
  endif()

  # Static libsz
  add_library(sz-static-objects OBJECT sz_compat.c)
  aec_common_include(sz-static-objects "${szlib_header}")
  add_library(sz-static STATIC
    "$<TARGET_OBJECTS:sz-static-objects>"
    "$<TARGET_OBJECTS:aec-static-objects>")
  target_link_libraries(sz-static PUBLIC sz-static-objects)
  set_target_properties(sz-static PROPERTIES OUTPUT_NAME sz)
  if(MSVC OR ("${CMAKE_C_SIMULATE_ID}" STREQUAL "MSVC"))
    set_target_properties(sz-static PROPERTIES OUTPUT_NAME szip-static)
  endif()
  # Add include directory directly to sz-static so config can get it.
  target_include_directories(sz-static
    PUBLIC "$<INSTALL_INTERFACE:include>")

  if(NOT BUILD_SHARED_LIBS)
    # Aliases if shared not built.
    add_library(libaec::aec ALIAS aec-static)
    add_library(libaec::sz ALIAS sz-static)
  endif()
endif()

# Simple executable for testing and benchmarking.
add_executable(graec graec.c)
target_link_libraries(graec libaec::aec)

if(UNIX)
  # The shell scripts for benchmarking are supported on unix only
  add_executable(utime EXCLUDE_FROM_ALL utime.c)
  target_include_directories(utime PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/..")
  add_custom_target(bench
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/benc.sh
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/typical.rz
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bdec.sh
    DEPENDS graec utime)
endif()

=== debian/changelog ===
libaec (1.1.5-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.3
  * Drop Priority: optional
  * Switch buildsystem to cmake to provide cmake config files
  * Include cmake files

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 26 Jan 2026 10:14:35 +0000

=== debian/control ===
Source: libaec
Section: utils
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 unzip,
 cmake
Rules-Requires-Root: no
Standards-Version: 4.7.3
Homepage: https://gitlab.dkrz.de/k202009/libaec
Vcs-Browser: https://salsa.debian.org/science-team/libaec
Vcs-Git: https://salsa.debian.org/science-team/libaec.git -b debian/latest

Package: libaec0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Adaptive Entropy Coding library
 Libaec provides fast lossless compression of 1 up to 32 bit wide
 signed or unsigned integers (samples). The library achieves best
 results for low entropy data as often encountered in space imaging
 instrument data or numerical model output from weather or climate
 simulations. While floating point representations are not directly
 supported, they can also be efficiently coded by grouping exponents
 and mantissa.
 .
 Libaec implements Golomb Rice coding as defined in the Space Data
 System Standard documents 121.0-B-2 [1] and 120.0-G-2[2].

Package: libsz2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Adaptive Entropy Coding library - SZIP
 Libaec provides fast lossless compression of 1 up to 32 bit wide
 signed or unsigned integers (samples).
 Libaec implements Golomb Rice coding as defined in the Space Data
 System Standard documents 121.0-B-2 [1] and 120.0-G-2[2].
 .
 This package provides a free drop-in replacement for the SZIP
 compression library.

Package: libaec-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libaec0 (= ${binary:Version}), libsz2 (= ${binary:Version})
Multi-Arch: same
Description: Development files for the Adaptive Entropy Coding library
 Libaec provides fast lossless compression of 1 up to 32 bit wide
 signed or unsigned integers (samples). The library achieves best
 results for low entropy data as often encountered in space imaging
 instrument data or numerical model output from weather or climate
 simulations. While floating point representations are not directly
 supported, they can also be efficiently coded by grouping exponents
 and mantissa.

## libaec 1.1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.26...3.31)
-project(libaec LANGUAGES C VERSION 1.1.5)
+project(libaec LANGUAGES C VERSION 1.1.6)
 
 option(BUILD_SHARED_LIBS "OFF: do not build shared libraries.  ON (default): build shared libraries" ON)
 option(BUILD_STATIC_LIBS "OFF: do not build static libraries.  ON (default): build static libraries" ON)
@@ -61,8 +61,10 @@
 
   add_subdirectory(fuzzing)
   set(FUZZ_TARGET_SAN_FLAGS -fsanitize=fuzzer-no-link,address,undefined)
-  target_compile_options(aec PUBLIC -g -O1 ${FUZZ_TARGET_SAN_FLAGS})
-  target_link_options(aec PUBLIC ${FUZZ_TARGET_SAN_FLAGS})
+  target_compile_options(aec-shared-objects PUBLIC -g -O1 ${FUZZ_TARGET_SAN_FLAGS})
+  target_link_options(aec-shared PUBLIC ${FUZZ_TARGET_SAN_FLAGS})
+  target_compile_options(sz-shared-objects PUBLIC -g -O1 ${FUZZ_TARGET_SAN_FLAGS})
+  target_link_options(sz-shared PUBLIC ${FUZZ_TARGET_SAN_FLAGS})
 endif()
 
 # Include the install rules if the user wanted them (included by

=== fuzzing/CMakeLists.txt ===
add_executable(fuzz_target fuzz_target.cc)
target_link_libraries(fuzz_target PUBLIC libaec::aec)

# Actually link libFuzzer
target_link_options(fuzz_target PRIVATE -fsanitize=fuzzer)

add_executable(fuzz_target_sz fuzz_target_sz.cc)
target_link_libraries(fuzz_target_sz PUBLIC libaec::sz)

# Actually link libFuzzer
target_link_options(fuzz_target_sz PRIVATE -fsanitize=fuzzer)

=== packaging/CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
     EXPORT libaec_static_targets
     PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
 
-  install(EXPORT libaec_shared_targets
+  install(EXPORT libaec_static_targets
     DESTINATION "${libaec_INSTALL_CMAKEDIR}"
     NAMESPACE libaec::
     FILE libaec_static-targets.cmake)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
   # Shared libaec versioning
   set(libaec_VERSION_MAJOR 0)
   set(libaec_VERSION_MINOR 1)
-  set(libaec_VERSION_PATCH 5)
+  set(libaec_VERSION_PATCH 6)
 
   # libtool compatible versioning for Mach-O
   math(EXPR libaec_MACHO_COMPATIBILITY_VERSION

=== debian/changelog ===
libaec (1.1.6-1) unstable; urgency=medium

  * New upstream release
  * d/gpb.conf: pristine-tar = True
  * Move d/copyright to DEP5
  * README.SZIP moved to doc/

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Feb 2026 06:54:42 +0000

=== debian/rules ===
#!/usr/bin/make -f

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

# To enable all, uncomment following line
DEB_BUILD_MAINT_OPTIONS:= hardening=+all
export DEB_BUILD_MAINT_OPTIONS

# cp debian/test-data/* tests

override_dh_auto_clean:
	rm -f tests/*.zip
	dh_auto_clean
